/*
========================================

========================================
*/

/* 
	STRUCTS
*/
struct SC2_Header
(
	boneoffset,
	wbonecount,    
	vertoffset,
	evertoffset, --omitted in supcom1.0, leave as 0
	vertcount,
	indexoffset, 
	indexcount,
	infooffset, 
	infocount, 
	totalbones,
	xtraoffset,
	--xtravalue,
	materialoffset,
	materialnum,
	
	fn DebugOut=
	(
		format "SCM_Header\n----------\n"
		--format "Marker: %, version: %\n" fourcc version
		format "Weighted bones: %, Total bones: %\n" wbonecount totalbones
		format "Vertex count: %, Trianlge count: %\n" vertcount ( indexcount / 3 )
		format "bOffset: %, vOffset: %, tOffset: %, iOffset %, xOffset %\n" boneoffset vertoffset indexoffset infooffset xtraoffset
		ok
	)
)
struct SC2_Bonelist
(
	bones=#(),
	offset=#(),
	padding
)
struct SC2_Bone
(
	RestPoseInverse1, 	--4x4 Matrix with row major
	RestPoseInverse2,	--row2 
	RestPoseInverse3,	--row3
	RestPoseInverse4,	--row4
	Position,					--vector(x,z,y) pos relative to parent bone
	Rotation,				--quaternion(w,x,y,z) rot relative to parent bone
	nameoffset,			--long
	parentboneindex,		--long
	reserved0,				--long				
	reserved1,				--long
	name					--name
)
struct SC2_Vertex
(
	position,
	normal,
	tangent,
	bitangent,
	uv1,
	uv2,
	boneindex=#(),
	boneweights=#()
)